package com.sun.xml.internal.ws.spi.db;

import java.util.logging.Level;
import java.lang.reflect.InvocationTargetException;
import java.security.AccessController;
import java.security.PrivilegedAction;
import java.lang.reflect.Method;
import java.lang.reflect.Field;
import java.lang.reflect.Type;
import com.sun.xml.internal.bind.v2.model.nav.Navigator;
import java.util.logging.Logger;

final class Utils
{
    private static final Logger LOGGER;
    static final Navigator<Type, Class, Field, Method> REFLECTION_NAVIGATOR;
    
    private Utils() {
    }
    
    static {
        LOGGER = Logger.getLogger(Utils.class.getName());
        try {
            final Class<Object> refNav = Class.forName("com.sun.xml.internal.bind.v2.model.nav.ReflectionNavigator");
            Method getInstance = (Method)AccessController.doPrivileged(new PrivilegedAction<Method>() {
                @Override
                public Method run() {
                    try {
                        Method getInstance = refNav.getDeclaredMethod("getInstance", new Class[0]);
                        getInstance.setAccessible(true);
                        return getInstance;
                    }
                    catch (NoSuchMethodException e) {
                        throw new IllegalStateException("ReflectionNavigator.getInstance can't be found");
                    }
                }
            });
            REFLECTION_NAVIGATOR = (Navigator)getInstance.invoke(null, new Object[0]);
        }
        catch (ClassNotFoundException e) {
            throw new IllegalStateException("Can't find ReflectionNavigator class");
        }
        catch (InvocationTargetException e2) {
            throw new IllegalStateException("ReflectionNavigator.getInstance throws the exception");
        }
        catch (IllegalAccessException e3) {
            throw new IllegalStateException("ReflectionNavigator.getInstance method is inaccessible");
        }
        catch (SecurityException e4) {
            Utils.LOGGER.log(Level.FINE, "Unable to access ReflectionNavigator.getInstance", e4);
            throw e4;
        }
    }
}
